function LiveFox() {
};


LiveFox.Settings = {
  preferences: null,
  OPEN_IN: {
    TAB: 0,
    WINDOW: 1
  },
  startup: function() {
    LiveFox.Settings.self = this;
    this.preferences = LiveFox.Preferences.get();
    LiveFox.Settings.load();
  },
  load: function() {
    var prefs = LiveFox.Settings.preferences;
    var ndx = prefs.general.openInTab 
              ? LiveFox.Settings.OPEN_IN.TAB
              : LiveFox.Settings.OPEN_IN.WINDOW;
    document.getElementById("openin").selectedIndex=ndx;
    if (prefs.matches.league.get) {
      document.getElementById("chkGetLeague").checked=true;
      if (prefs.matches.league.within) {
        document.getElementById("txtGetLeagueWithinHours").disabled=false;
      } else {
        document.getElementById("txtGetLeagueWithinHours").disabled=true;
      }
    } else {
      document.getElementById("chkGetLeague").checked=false;
      document.getElementById("chkGetLeagueWithin").disabled=true;
      document.getElementById("txtGetLeagueWithinHours").disabled=true;
    }
    document.getElementById("chkGetLeagueWithin").checked=prefs.matches.league.within;
    document.getElementById("txtGetLeagueWithinHours").value=prefs.matches.league.withinHours;

    if (prefs.matches.friends.get) {
      document.getElementById("chkGetFriends").checked=true;
      if (prefs.matches.friends.within) {
        document.getElementById("txtGetFriendsWithinHours").disabled=false;
      } else {
        document.getElementById("txtGetFriendsWithinHours").disabled=true;
      }
    } else {
      document.getElementById("chkGetFriends").checked=false;
      document.getElementById("chkGetFriendsWithin").disabled=true;
      document.getElementById("txtGetFriendsWithinHours").disabled=true;
    }
    document.getElementById("chkGetFriendsWithin").checked=prefs.matches.friends.within;
    document.getElementById("txtGetFriendsWithinHours").value=prefs.matches.friends.withinHours;
    
    document.getElementById("chkHdrScorers").checked=prefs.matches.scorers;
    
    document.getElementById("txtMatchWindowSize").value=prefs.matches.windowSize;
    
    document.getElementById("chkSound").checked=prefs.notification.sound;
    if (!prefs.notification.sound) {
      document.getElementById("chkSoundOnlyOpened").disabled=true;
    }
    document.getElementById("chkSoundOnlyOpened").checked = prefs.notification.soundOnlyOpened;
    document.getElementById("chkFlash").checked = prefs.notification.flash;
    document.getElementById("chkSlider").checked = prefs.notification.slider;

    document.getElementById("lang-list").value = prefs.language.locale;
  },
  save: function() {
    LiveFox.Log.properties(this.preferences.notification);
    LiveFox.Preferences.save(this.preferences);
  },
  click: {
    btnCancel: function() {
      window.close();
    },
    btnOk: function() {
      LiveFox.Settings.save();
      window.close();
    },
    radopenin: function() {
      var prefs = LiveFox.Settings.preferences;
      prefs.general.openInTab = (document.getElementById("openin").selectedIndex==LiveFox.Settings.OPEN_IN.TAB);

    },
    chkgetleague: function() {
      var prefs = LiveFox.Settings.preferences;
      if(document.getElementById("chkGetLeague").checked) {
        document.getElementById("chkGetLeagueWithin").disabled = false;
        LiveFox.Settings.click.chkgetleaguewithin();
        prefs.matches.league.get = true;
      } else {
        document.getElementById("chkGetLeagueWithin").disabled = true;
        document.getElementById("txtGetLeagueWithinHours").disabled = true;
        prefs.matches.league.get = false;
      }
    },
    chkgetleaguewithin: function() {
      var prefs = LiveFox.Settings.preferences;
      if(document.getElementById("chkGetLeagueWithin").checked) {
        document.getElementById("txtGetLeagueWithinHours").disabled = false;
        prefs.matches.league.within = true;
      } else {
        document.getElementById("txtGetLeagueWithinHours").disabled = true;
        prefs.matches.league.within = false;
      };
    },
    txtfixleaguehours: function() {
      var prefs = LiveFox.Settings.preferences;
      var value = document.getElementById("txtGetLeagueWithinHours").value.replace(/\D/g, "");
      document.getElementById("txtGetLeagueWithinHours").value = value;
      prefs.matches.league.withinHours = value;
    },
    chkgetfriends: function() {
      var prefs = LiveFox.Settings.preferences;
      if(document.getElementById("chkGetFriends").checked) {
        document.getElementById("chkGetFriendsWithin").disabled = false;
        LiveFox.Settings.click.chkgetfriendswithin();
        prefs.matches.friends.get = true;
      } else {
        document.getElementById("chkGetFriendsWithin").disabled = true;
        document.getElementById("txtGetFriendsWithinHours").disabled = true;
        prefs.matches.friends.get = false;
      }
    },
    chkgetfriendswithin: function() {
      var prefs = LiveFox.Settings.preferences;
      if(document.getElementById("chkGetFriendsWithin").checked) {
        document.getElementById("txtGetFriendsWithinHours").disabled = false;
        prefs.matches.friends.within = true;
      } else {
        document.getElementById("txtGetFriendsWithinHours").disabled = true;
        prefs.matches.friends.within = false;
      };
    },
    txtfixfriendshours: function() {
      var prefs = LiveFox.Settings.preferences;
      var value = document.getElementById("txtGetFriendsWithinHours").value.replace(/\D/g, "");
      document.getElementById("txtGetFriendsWithinHours").value = value;
      prefs.matches.friends.withinHours = value;
    },
    chkhdrscorers: function() {
      var prefs = LiveFox.Settings.preferences;
      prefs.matches.scorers = document.getElementById("chkHdrScorers").checked;
    },
    txtfixwindowsize: function() {
      var prefs = LiveFox.Settings.preferences;
      var value = document.getElementById("txtMatchWindowSize").value.replace(/\D/g, "");
      document.getElementById("txtMatchWindowSize").value = value;
      prefs.matches.windowSize = value;
    },
    chkSound: function() {
      var prefs = LiveFox.Settings.preferences;
      if(document.getElementById("chkSound").checked) {
        document.getElementById("chkSoundOnlyOpened").disabled = false;
        prefs.notification.sound = true;
      } else {
        document.getElementById("chkSoundOnlyOpened").disabled = true;
        prefs.notification.sound = false;
      };
    },
    chkSoundOnlyOpened: function() {
      var prefs = LiveFox.Settings.preferences;
      if(document.getElementById("chkSoundOnlyOpened").checked) {
        prefs.notification.soundOnlyOpened = true;
      } else {
        prefs.notification.soundOnlyOpened = false;
      };
    },
    chkFlash: function() {
      var prefs = LiveFox.Settings.preferences;
      if(document.getElementById("chkFlash").checked) {
        prefs.notification.flash = true;
      } else {
        prefs.notification.flash = false;
      };
    },
    chkSlider: function() {
      var prefs = LiveFox.Settings.preferences;
      if(document.getElementById("chkSlider").checked) {
        prefs.notification.slider = true;
      } else {
        prefs.notification.slider = false;
      };
    },
    selLang: function() {
      var prefs = LiveFox.Settings.preferences;
      var newLang = document.getElementById("lang-list").selectedItem.value;
      prefs.language.locale = newLang;
    }
  }
}
